/* ItemProvider.c generated by valac 0.56.18, the Vala compiler
 * generated from ItemProvider.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include "slingshot.h"
#include <gio/gio.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType synapse_item_provider_type_id = 0;

static gboolean synapse_item_provider_real_handles_query (SynapseItemProvider* self,
                                                   SynapseQuery* query);
static gboolean synapse_item_provider_real_handles_empty_query (SynapseItemProvider* self);

void
synapse_item_provider_search (SynapseItemProvider* self,
                              SynapseQuery* query,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	SynapseItemProviderIface* _iface_;
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
	if (_iface_->search) {
		_iface_->search (self, query, _callback_, _user_data_);
	}
}

SynapseResultSet*
synapse_item_provider_search_finish (SynapseItemProvider* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	SynapseItemProviderIface* _iface_;
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
	if (_iface_->search_finish) {
		return _iface_->search_finish (self, _res_, error);
	}
	return NULL;
}

static gboolean
synapse_item_provider_real_handles_query (SynapseItemProvider* self,
                                          SynapseQuery* query)
{
	gboolean result;
	g_return_val_if_fail (query != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
synapse_item_provider_handles_query (SynapseItemProvider* self,
                                     SynapseQuery* query)
{
	SynapseItemProviderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
	if (_iface_->handles_query) {
		return _iface_->handles_query (self, query);
	}
	return FALSE;
}

static gboolean
synapse_item_provider_real_handles_empty_query (SynapseItemProvider* self)
{
	gboolean result;
	result = FALSE;
	return result;
}

gboolean
synapse_item_provider_handles_empty_query (SynapseItemProvider* self)
{
	SynapseItemProviderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
	if (_iface_->handles_empty_query) {
		return _iface_->handles_empty_query (self);
	}
	return FALSE;
}

static void
synapse_item_provider_default_init (SynapseItemProviderIface * iface,
                                    gpointer iface_data)
{
	iface->handles_query = synapse_item_provider_real_handles_query;
	iface->handles_empty_query = synapse_item_provider_real_handles_empty_query;
}

GType
synapse_item_provider_get_type (void)
{
	return synapse_item_provider_type_id;
}

GType
synapse_item_provider_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseItemProviderIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_item_provider_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	synapse_item_provider_type_id = g_type_module_register_type (module, G_TYPE_INTERFACE, "SynapseItemProvider", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (synapse_item_provider_type_id, SYNAPSE_TYPE_ACTIVATABLE);
	return synapse_item_provider_type_id;
}

